diff --git a/src/modules/CUVID/CuvidDec.hpp b/src/modules/CUVID/CuvidDec.hpp
index 82ecc346..0b959c14 100644
--- a/src/modules/CUVID/CuvidDec.hpp
+++ b/src/modules/CUVID/CuvidDec.hpp
@@ -33,7 +33,7 @@ struct AVBSFContext;
 struct SwsContext;
 struct AVPacket;
 
-class CuvidDec final : public Decoder
+class CuvidDec : public Decoder
 {
     Q_DECLARE_TR_FUNCTIONS(CuvidDec)
 
@@ -43,25 +43,25 @@ public:
     CuvidDec(Module &module);
     ~CuvidDec();
 
-    bool set() override;
+    bool set();
 
     int videoSequence(CUVIDEOFORMAT *format);
     int pictureDecode(CUVIDPICPARAMS *picParams);
     int pictureDisplay(CUVIDPARSERDISPINFO *dispInfo);
 
 private:
-    QString name() const override;
+    QString name() const;
 
-    bool hasHWDecContext() const override;
-    std::shared_ptr<VideoFilter> hwAccelFilter() const override;
+    bool hasHWDecContext() const;
+    std::shared_ptr<VideoFilter> hwAccelFilter() const;
 
-    void setSupportedPixelFormats(const AVPixelFormats &pixelFormats) override;
+    void setSupportedPixelFormats(const AVPixelFormats &pixelFormats);
 
-    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurry_up) override;
+    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurry_up);
 
-    bool hasCriticalError() const override;
+    bool hasCriticalError() const;
 
-    bool open(StreamInfo &streamInfo) override;
+    bool open(StreamInfo &streamInfo);
 
     /**/
 
diff --git a/src/modules/CUVID/CuvidOpenGL.cpp b/src/modules/CUVID/CuvidOpenGL.cpp
index bac00ae8..50b766a5 100644
--- a/src/modules/CUVID/CuvidOpenGL.cpp
+++ b/src/modules/CUVID/CuvidOpenGL.cpp
@@ -19,7 +19,7 @@
 #include <CuvidOpenGL.hpp>
 #include <Frame.hpp>
 
-#include <QOpenGLContext>
+#include <QtOpenGL/QGLContext>
 #include <QImage>
 
 extern "C" {
diff --git a/src/modules/CUVID/CuvidOpenGL.hpp b/src/modules/CUVID/CuvidOpenGL.hpp
index 0a524144..50426b5e 100644
--- a/src/modules/CUVID/CuvidOpenGL.hpp
+++ b/src/modules/CUVID/CuvidOpenGL.hpp
@@ -21,23 +21,23 @@
 #include <CuvidHWInterop.hpp>
 #include <opengl/OpenGLHWInterop.hpp>
 
-class CuvidOpenGL final : public CuvidHWInterop, public OpenGLHWInterop
+class CuvidOpenGL : public CuvidHWInterop, public OpenGLHWInterop
 {
 public:
     CuvidOpenGL(const std::shared_ptr<CUcontext> &cuCtx);
     ~CuvidOpenGL();
 
-    QString name() const override;
+    QString name() const;
 
-    Format getFormat() const override;
+    Format getFormat() const;
 
-    bool init(const int *widths, const int *heights, const SetTextureParamsFn &setTextureParamsFn) override;
-    void clear() override;
+    bool init(const int *widths, const int *heights, const SetTextureParamsFn &setTextureParamsFn);
+    void clear();
 
-    bool mapFrame(Frame &videoFrame) override;
-    quint32 getTexture(int plane) override;
+    bool mapFrame(Frame &videoFrame);
+    quint32 getTexture(int plane);
 
-    Frame getCpuFrame(const Frame &videoFrame) override;
+    Frame getCpuFrame(const Frame &videoFrame);
 
 private:
     quint32 m_textures[2] = {};
diff --git a/src/modules/CUVID/CuvidVulkan.hpp b/src/modules/CUVID/CuvidVulkan.hpp
index 4a1517ee..51fd58f2 100644
--- a/src/modules/CUVID/CuvidVulkan.hpp
+++ b/src/modules/CUVID/CuvidVulkan.hpp
@@ -28,18 +28,18 @@ class ImagePool;
 class Semaphore;
 }
 
-class CuvidVulkan final : public CuvidHWInterop, public QmVk::HWInterop
+class CuvidVulkan : public CuvidHWInterop, public QmVk::HWInterop
 {
 public:
     CuvidVulkan(const std::shared_ptr<CUcontext> &cuCtx);
     ~CuvidVulkan();
 
-    QString name() const override;
+    QString name() const;
 
-    void map(Frame &frame) override;
-    void clear() override;
+    void map(Frame &frame);
+    void clear();
 
-    SyncDataPtr sync(const std::vector<Frame> &frames, vk::SubmitInfo *submitInfo = nullptr) override;
+    SyncDataPtr sync(const std::vector<Frame> &frames, vk::SubmitInfo *submitInfo = nullptr);
 
 private:
     void ensureSemaphore();
diff --git a/src/modules/Chiptune/Chiptune.hpp b/src/modules/Chiptune/Chiptune.hpp
index 8455193a..9770ff7b 100644
--- a/src/modules/Chiptune/Chiptune.hpp
+++ b/src/modules/Chiptune/Chiptune.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class Chiptune final : public Module
+class Chiptune : public Module
 {
 public:
     Chiptune();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 
     QIcon GMEIcon, SIDIcon;
 };
@@ -40,13 +40,13 @@ private:
 class QCheckBox;
 class QSpinBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
 #ifdef USE_GME
     QCheckBox *gmeB;
diff --git a/src/modules/Chiptune/GME.hpp b/src/modules/Chiptune/GME.hpp
index 952c31e9..a7ffe641 100644
--- a/src/modules/Chiptune/GME.hpp
+++ b/src/modules/Chiptune/GME.hpp
@@ -24,28 +24,28 @@
 
 class Reader;
 
-class GME final : public Demuxer
+class GME : public Demuxer
 {
     Q_DECLARE_TR_FUNCTIONS(GME)
 public:
     GME(Module &);
     ~GME();
 private:
-    bool set() override;
+    bool set();
 
-    QString name() const override;
-    QString title() const override;
-    QList<QMPlay2Tag> tags() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const;
+    QString title() const;
+    QList<QMPlay2Tag> tags() const;
+    double length() const;
+    int bitrate() const;
 
-    bool seek(double, bool) override;
-    bool read(Packet &, int &) override;
-    void abort() override;
+    bool seek(double, bool);
+    bool read(Packet &, int &);
+    void abort();
 
-    bool open(const QString &) override;
+    bool open(const QString &);
 
-    Playlist::Entries fetchTracks(const QString &url, bool &ok) override;
+    Playlist::Entries fetchTracks(const QString &url, bool &ok);
 
 
     bool open(const QString &url, bool tracksOnly);
diff --git a/src/modules/Chiptune/SIDPlay.hpp b/src/modules/Chiptune/SIDPlay.hpp
index b9b9feb0..27ded134 100644
--- a/src/modules/Chiptune/SIDPlay.hpp
+++ b/src/modules/Chiptune/SIDPlay.hpp
@@ -31,28 +31,28 @@
 class SidTuneInfo;
 class Reader;
 
-class SIDPlay final : public Demuxer
+class SIDPlay : public Demuxer
 {
     Q_DECLARE_TR_FUNCTIONS(SIDPlay)
 public:
     SIDPlay(Module &);
     ~SIDPlay();
 private:
-    bool set() override;
+    bool set();
 
-    QString name() const override;
-    QString title() const override;
-    QList<QMPlay2Tag> tags() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const;
+    QString title() const;
+    QList<QMPlay2Tag> tags() const;
+    double length() const;
+    int bitrate() const;
 
-    bool seek(double, bool backward) override;
-    bool read(Packet &, int &) override;
-    void abort() override;
+    bool seek(double, bool backward);
+    bool read(Packet &, int &);
+    void abort();
 
-    bool open(const QString &) override;
+    bool open(const QString &);
 
-    Playlist::Entries fetchTracks(const QString &url, bool &ok) override;
+    Playlist::Entries fetchTracks(const QString &url, bool &ok);
 
 
     bool open(const QString &url, bool tracksOnly);
diff --git a/src/modules/DirectX/DirectDraw.hpp b/src/modules/DirectX/DirectDraw.hpp
index 06d1cd56..413fcdbe 100644
--- a/src/modules/DirectX/DirectDraw.hpp
+++ b/src/modules/DirectX/DirectDraw.hpp
@@ -28,7 +28,7 @@
 
 class DirectDrawWriter;
 
-class Drawable final : public QWidget
+class Drawable : public QWidget
 {
     Q_OBJECT
 public:
@@ -48,7 +48,7 @@ public:
 
     void draw(const Frame &videoFrame);
 
-    void resizeEvent(QResizeEvent *) override;
+    void resizeEvent(QResizeEvent *);
 
     QMPlay2OSDList osd_list;
     bool isOK, isOverlay, paused;
@@ -63,10 +63,10 @@ private:
 
     bool restoreLostSurface();
 
-    void paintEvent(QPaintEvent *) override;
-    bool event(QEvent *) override;
+    void paintEvent(QPaintEvent *);
+    bool event(QEvent *);
 
-    QPaintEngine *paintEngine() const override;
+    QPaintEngine *paintEngine() const;
 
     QImage osdImg;
     QVector<quint64> osd_ids;
@@ -89,7 +89,7 @@ private:
 
 /**/
 
-class DirectDrawWriter final : public VideoWriter
+class DirectDrawWriter : public VideoWriter
 {
     friend class Drawable;
 public:
@@ -97,18 +97,18 @@ public:
 private:
         ~DirectDrawWriter();
 
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
-    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList) override;
+    bool processParams(bool *paramsCorrected);
+    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList);
 
-    void pause() override;
+    void pause();
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
     /**/
 
diff --git a/src/modules/DirectX/DirectX.hpp b/src/modules/DirectX/DirectX.hpp
index c9495e86..380d59d8 100644
--- a/src/modules/DirectX/DirectX.hpp
+++ b/src/modules/DirectX/DirectX.hpp
@@ -22,29 +22,29 @@
 
 #include <QCoreApplication>
 
-class DirectX final : public Module
+class DirectX : public Module
 {
 public:
     DirectX();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 };
 
 /**/
 
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QCheckBox *ddrawB;
 };
diff --git a/src/modules/Extensions/CMakeLists.txt b/src/modules/Extensions/CMakeLists.txt
index e521ee5e..587eeed8 100644
--- a/src/modules/Extensions/CMakeLists.txt
+++ b/src/modules/Extensions/CMakeLists.txt
@@ -80,6 +80,7 @@ endif()
 target_link_libraries(${PROJECT_NAME}
     PRIVATE
     ${QML}
+    ${QJSON4_LIBRARY}
 )
 libqmplay2_set_target_params()
 
diff --git a/src/modules/Extensions/Downloader.cpp b/src/modules/Extensions/Downloader.cpp
index e6d8c2b1..c982a76b 100644
--- a/src/modules/Extensions/Downloader.cpp
+++ b/src/modules/Extensions/Downloader.cpp
@@ -31,8 +31,12 @@
 #include <QTimer>
 #include <QLabel>
 #include <QAction>
-#include <QScreen>
-#include <QWindow>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    #include <QScreen>
+    #include <QWindow>
+#else
+    #include <QDesktopWidget>
+#endif
 #include <QProcess>
 #include <QMimeData>
 #include <QFileInfo>
@@ -48,12 +52,31 @@
 #include <QProgressBar>
 #include <QApplication>
 #include <QElapsedTimer>
-#include <QLoggingCategory>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
+    #include <QLoggingCategory>
+#else
+    #include <QDebug>
+#endif
 #include <QDialogButtonBox>
 
 #include <functional>
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
 Q_LOGGING_CATEGORY(downloader, "Downloader")
+#else
+    // Qt4: Create a simple logger class for compatibility
+    class DownloaderLogger {
+    public:
+        DownloaderLogger() : m_debug(qWarning()) {}
+        QDebug &noquote() { return m_debug.nospace(); }
+        operator QDebug&() { return m_debug; }
+        QDebug& operator<<(const QString &s) { m_debug << s; return m_debug; }
+    private:
+        QDebug m_debug;
+    };
+    #define qCWarning(category) DownloaderLogger()
+    #define qCDebug(category) DownloaderLogger()
+#endif
 
 /**/
 
@@ -67,7 +90,8 @@ constexpr const char *g_conversionError = QT_TRANSLATE_NOOP("DownloadItemW", "Co
 
 /**/
 
-static QStringView getCommandOutput(const QString &command)
+// Qt4: Return QString instead of QStringView
+static QString getCommandOutput(const QString &command)
 {
     const int idx1 = command.indexOf("<output>");
     if (idx1 < 0)
@@ -77,7 +101,7 @@ static QStringView getCommandOutput(const QString &command)
     if (idx2 < 0)
         return {};
 
-    return QStringView(command).mid(idx1 + 8, idx2 - idx1 - 8);
+    return command.mid(idx1 + 8, idx2 - idx1 - 8);
 }
 
 static void maybeAddAbsolutePath(QString &convertCommand)
@@ -361,7 +385,11 @@ void DownloadItemW::downloadStop(bool ok)
     finished = true;
     if (!dontDeleteDownloadThr)
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         if (visibleRegion().isNull())
+#else
+        if (visibleRegion().isEmpty())
+#endif
             emit QMPlay2Core.sendMessage(titleL->text(), sizeL->text());
     }
 }
@@ -371,31 +399,18 @@ void DownloadItemW::startConversion()
     deleteConvertProcess();
 
     m_convertProcess = new QProcess(this);
-    m_convertProcessConn[0] = connect(m_convertProcess, qOverload<int, QProcess::ExitStatus>(&QProcess::finished), this, [this](int exitCode, QProcess::ExitStatus exitStatus) {
-        Q_UNUSED(exitStatus)
-        if (exitCode == 0)
-        {
-            sizeL->setText(tr(g_downloadComplete));
-            QFile::remove(filePath);
-            m_needsConversion = false;
-            filePath = m_convertedFilePath;
-            downloadStop(true);
-        }
-        else
-        {
-            sizeL->setText(tr(g_conversionError));
-            qCWarning(downloader) << "Failed to convert:" << m_convertProcess->program() << m_convertProcess->arguments() << m_convertProcess->readAllStandardError().constData();
-            downloadStop(false);
-        }
-    });
-    m_convertProcessConn[1] = connect(m_convertProcess, &QProcess::errorOccurred, this, [this](QProcess::ProcessError error) {
-        if (error == QProcess::FailedToStart)
-        {
-            sizeL->setText(tr(g_conversionError));
-            downloadStop(false);
-            qCWarning(downloader) << "Failed to start process:" << m_convertProcess->program();
-        }
-    });
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    m_convertProcessConn[0] = connect(m_convertProcess, SIGNAL(finished(int, QProcess::ExitStatus)),
+                                      this, SLOT(onConvertProcessFinished(int, QProcess::ExitStatus)));
+    m_convertProcessConn[1] = connect(m_convertProcess, SIGNAL(error(QProcess::ProcessError)),
+                                      this, SLOT(onConvertProcessError(QProcess::ProcessError)));
+#else
+    // Qt4: Direct connect without storing connection
+    connect(m_convertProcess, SIGNAL(finished(int, QProcess::ExitStatus)),
+            this, SLOT(onConvertProcessFinished(int, int)));
+    connect(m_convertProcess, SIGNAL(error(QProcess::ProcessError)),
+            this, SLOT(onConvertProcessError(int)));
+#endif
 
     m_needsConversion = true;
     finished = false;
@@ -436,7 +451,7 @@ void DownloadItemW::startConversion()
     const int idx1 = convertCommand.indexOf("<output>");
     const int idx2 = convertCommand.indexOf("</output>", idx1);
 
-    m_convertedFilePath = getCommandOutput(convertCommand).toString();
+    m_convertedFilePath = getCommandOutput(convertCommand);
     m_convertedFilePath.replace("%f", Functions::filePath(filePath) + Functions::fileName(filePath, false));
     if (m_convertedFilePath.isEmpty() || idx1 < 0 || idx2 < idx1)
     {
@@ -453,25 +468,95 @@ void DownloadItemW::startConversion()
     maybeAddAbsolutePath(convertCommand);
 
     qDebug() << "Starting conversion:" << convertCommand.toUtf8().constData();
+#if QT_VERSION >= QT_VERSION_CHECK(5, 15, 0)
     auto args = QProcess::splitCommand(convertCommand);
     if (!args.isEmpty())
     {
         const QString program = args.takeFirst();
         m_convertProcess->start(program, args);
     }
+#else
+    // Qt4: Use shell to execute command
+    m_convertProcess->start("/bin/sh", QStringList() << "-c" << convertCommand);
+#endif
 }
 void DownloadItemW::deleteConvertProcess()
 {
     if (m_convertProcess)
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         disconnect(m_convertProcessConn[0]);
         disconnect(m_convertProcessConn[1]);
+#else
+        // Qt4: Disconnect all signals from m_convertProcess
+        disconnect(m_convertProcess, 0, this, 0);
+#endif
         m_convertProcess->close();
         delete m_convertProcess;
         m_convertProcess = nullptr;
     }
 }
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+void DownloadItemW::onConvertProcessFinished(int exitCode, QProcess::ExitStatus exitStatus)
+{
+    Q_UNUSED(exitStatus)
+    if (exitCode == 0)
+    {
+        sizeL->setText(tr(g_downloadComplete));
+        QFile::remove(filePath);
+        m_needsConversion = false;
+        filePath = m_convertedFilePath;
+        downloadStop(true);
+    }
+    else
+    {
+        sizeL->setText(tr(g_conversionError));
+        qCWarning(downloader) << "Failed to convert:" << m_convertProcess->program() << m_convertProcess->arguments() << m_convertProcess->readAllStandardError().constData();
+        downloadStop(false);
+    }
+}
+
+void DownloadItemW::onConvertProcessError(QProcess::ProcessError error)
+{
+    if (error == QProcess::FailedToStart)
+    {
+        sizeL->setText(tr(g_conversionError));
+        downloadStop(false);
+        qCWarning(downloader) << "Failed to start process:" << m_convertProcess->program();
+    }
+}
+#else
+void DownloadItemW::onConvertProcessFinished(int exitCode, int exitStatus)
+{
+    Q_UNUSED(exitStatus)
+    if (exitCode == 0)
+    {
+        sizeL->setText(tr(g_downloadComplete));
+        QFile::remove(filePath);
+        m_needsConversion = false;
+        filePath = m_convertedFilePath;
+        downloadStop(true);
+    }
+    else
+    {
+        sizeL->setText(tr(g_conversionError));
+        qCWarning(downloader) << "Failed to convert:" << m_convertProcess->readAllStandardError().constData();
+        downloadStop(false);
+    }
+}
+
+void DownloadItemW::onConvertProcessError(int error)
+{
+    if (error == QProcess::FailedToStart)
+    {
+        sizeL->setText(tr(g_conversionError));
+        downloadStop(false);
+        qCWarning(downloader) << "Failed to start process";
+    }
+}
+#endif
+
 /**/
 
 DownloaderThread::DownloaderThread(QDataStream *stream, const QString &url, DownloadListW *downloadLW, const QMenu *convertsMenu, const QString &name, const QString &prefix, const QString &param, const QString &preset) :
@@ -648,7 +733,7 @@ void DownloaderThread::run()
                 int i = 0;
                 selectedStreams.reserve(streamsInfo.count());
                 selectedStreamsMap.reserve(streamsInfo.count());
-                for (auto &&streamInfo : std::as_const(streamsInfo))
+                for (auto &&streamInfo : streamsInfo)
                 {
                     if (streamInfo->params->codec_type == AVMEDIA_TYPE_VIDEO && streamInfo->is_default)
                     {
@@ -912,7 +997,7 @@ void Downloader::init()
     connect(downloadLW, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)), this, SLOT(itemDoubleClicked(QTreeWidgetItem *)));
 
     m_convertsMenu = new QMenu(this);
-    connect(m_convertsMenu->addAction(tr("&Add")), &QAction::triggered, this, &Downloader::addConvertPreset);
+    connect(m_convertsMenu->addAction(tr("&Add")), SIGNAL(triggered()), this, SLOT(addConvertPreset()));
     m_convertsMenu->addSeparator();
 
     clearFinishedB = new QToolButton;
@@ -975,7 +1060,7 @@ void Downloader::init()
         const auto createPreset = [this](const QString &name, const QString &data) {
             QAction *act = m_convertsMenu->addAction(name);
             act->setData(data);
-            connect(act, &QAction::triggered, this, &Downloader::editConvertAction);
+            connect(act, SIGNAL(triggered()), this, SLOT(editConvertAction()));
             return act;
         };
 
@@ -1022,7 +1107,7 @@ QVector<QAction *> Downloader::getActions(const QString &name, double, const QSt
     const auto createAction = [&](const QString &actionName, const QString &preset) {
         QAction *act = new QAction(actionName, nullptr);
         act->setIcon(QIcon(":/downloader.svgz"));
-        act->connect(act, &QAction::triggered, this, &Downloader::download);
+        act->connect(act, SIGNAL(triggered()), this, SLOT(download()));
         act->setProperty("name", name);
         if (!prefix.isEmpty())
         {
@@ -1055,7 +1140,7 @@ void Downloader::addConvertPreset()
     QAction *action = m_convertsMenu->addAction("MP3 224k");
     action->setData(g_defaultMp3ConvertCommand);
     if (modifyConvertAction(action, false))
-        connect(action, &QAction::triggered, this, &Downloader::editConvertAction);
+        connect(action, SIGNAL(triggered()), this, SLOT(editConvertAction()));
     else
         action->deleteLater();
 }
@@ -1075,19 +1160,16 @@ bool Downloader::modifyConvertAction(QAction *action, bool addRemoveButton)
     commandE->setToolTip(tr("Command line to execute after download.\n\n<input/> - specifies downloaded file.\n<output>%f.mp3</output> - converted file will be input file with \"mp3\" extension."));
 
     QDialogButtonBox *buttons = new QDialogButtonBox(QDialogButtonBox::Ok | QDialogButtonBox::Cancel);
-    connect(buttons, &QDialogButtonBox::accepted, &dialog, &QDialog::accept);
-    connect(buttons, &QDialogButtonBox::rejected, &dialog, &QDialog::reject);
+    connect(buttons, SIGNAL(accepted()), &dialog, SLOT(accept()));
+    connect(buttons, SIGNAL(rejected()), &dialog, SLOT(reject()));
     if (addRemoveButton)
     {
         QPushButton *removeB = buttons->addButton(tr("Remove"), QDialogButtonBox::DestructiveRole);
         removeB->setIcon(QMPlay2Core.getIconFromTheme("list-remove"));
-        connect(buttons, &QDialogButtonBox::clicked, &dialog, [&](QAbstractButton *button) {
-            if (button == removeB)
-            {
-                action->deleteLater();
-                dialog.reject();
-            }
-        });
+        // Qt4: Store action pointer as property for the clicked handler
+        removeB->setProperty("targetAction", QVariant::fromValue(static_cast<QObject*>(action)));
+        connect(removeB, SIGNAL(clicked()), action, SLOT(deleteLater()));
+        connect(removeB, SIGNAL(clicked()), &dialog, SLOT(reject()));
     }
 
     QFormLayout *layout = new QFormLayout(&dialog);
@@ -1097,11 +1179,16 @@ bool Downloader::modifyConvertAction(QAction *action, bool addRemoveButton)
     layout->addRow(tr("Command line"), commandE);
     layout->addRow(buttons);
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     if (QWindow *win = window()->windowHandle())
     {
         if (QScreen *screen = win->screen())
             dialog.resize(screen->availableGeometry().width() / 2, 1);
     }
+#else
+    // Qt4: Use QDesktopWidget instead of QWindow/QScreen
+    dialog.resize(QApplication::desktop()->availableGeometry().width() / 2, 1);
+#endif
 
     while (dialog.exec() == QDialog::Accepted)
     {
diff --git a/src/modules/Extensions/Downloader.hpp b/src/modules/Extensions/Downloader.hpp
index 6ee25c59..ba493ef8 100644
--- a/src/modules/Extensions/Downloader.hpp
+++ b/src/modules/Extensions/Downloader.hpp
@@ -25,14 +25,24 @@
 #include <QToolButton>
 #include <QThread>
 
+#if QT_VERSION >= 0x050000
+    #include <QProcess>
+#else
+    #include <QProcess>
+    // Qt4: Forward declare enum types
+    namespace QProcessEnums {
+        enum ExitStatus { NormalExit, CrashExit };
+        enum ProcessError { FailedToStart, Crashed, Timedout, WriteError, ReadError, UnknownError };
+    }
+#endif
+
 class QLabel;
-class QProcess;
 class QGridLayout;
 class QProgressBar;
 class QTreeWidgetItem;
 class DownloaderThread;
 
-class DownloadItemW final : public QWidget
+class DownloadItemW : public QWidget
 {
     Q_OBJECT
 public:
@@ -69,6 +79,13 @@ signals:
     void stop();
 private slots:
     void toggleStartStop();
+#if QT_VERSION >= 0x050000
+    void onConvertProcessFinished(int exitCode, QProcess::ExitStatus exitStatus);
+    void onConvertProcessError(QProcess::ProcessError error);
+#else
+    void onConvertProcessFinished(int exitCode, int exitStatus);
+    void onConvertProcessError(int error);
+#endif
 private:
     void downloadStop(bool);
 
@@ -90,7 +107,9 @@ private:
     } *speedProgressW = nullptr;
 
     QProcess *m_convertProcess = nullptr;
+#if QT_VERSION >= 0x050000
     QMetaObject::Connection m_convertProcessConn[2];
+#endif
     bool finished, readyToPlay, m_needsConversion = false;
     QString m_convertPreset;
     QString filePath;
@@ -99,13 +118,13 @@ private:
 
 /**/
 
-class DownloadListW final : public QTreeWidget
+class DownloadListW : public QTreeWidget
 {
 };
 
 /**/
 
-class DownloaderThread final : public QThread
+class DownloaderThread : public QThread
 {
     Q_OBJECT
     enum {ADD_ENTRY, NAME, SET, SET_POS, SET_SPEED, DOWNLOAD_ERROR, FINISH};
@@ -123,7 +142,7 @@ private slots:
     void stop();
     void finished();
 private:
-    void run() override;
+    void run();
 
     QIcon getIcon();
 
@@ -137,7 +156,7 @@ private:
 
 /**/
 
-class Downloader final : public QWidget, public QMPlay2Extensions
+class Downloader : public QWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 
@@ -145,15 +164,17 @@ public:
     Downloader(Module &module);
     ~Downloader();
 
-    void init() override;
+    void init();
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget();
 
-    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &) override;
+    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &);
 
-private:
+private slots:
     void addConvertPreset();
     void editConvertAction();
+
+private:
     bool modifyConvertAction(QAction *action, bool addRemoveButton = true);
 
 private slots:
diff --git a/src/modules/Extensions/Extensions.hpp b/src/modules/Extensions/Extensions.hpp
index 9e559031..8eff8a6c 100644
--- a/src/modules/Extensions/Extensions.hpp
+++ b/src/modules/Extensions/Extensions.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class Extensions final : public Module
+class Extensions : public Module
 {
 public:
     Extensions();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 
     QIcon downloader;
 #ifdef USE_YOUTUBE
@@ -54,7 +54,7 @@ class QGroupBox;
 class QCheckBox;
 class LineEdit;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_OBJECT
 public:
@@ -65,7 +65,7 @@ private slots:
     void passwordEdited();
 #endif
 private:
-    void saveSettings() override;
+    void saveSettings();
 
 #ifdef USE_MPRIS2
     QCheckBox *MPRIS2B;
